function EstimOptions = EstimSet(t,Z,Xf00,Pf0,theta0,FileNames,LKWindow,mpts,nu_stast,LB,UB,OptimMethod,OptimOptions,AbsTol,RelTol)
% Imputs:
%   Xf00: Initial estimate for Xf0
%   theta0: Initial estimate for theta
%   LogLK0: Initial value of LogLK
%   nu_stast: Initial value of the innovation statistics 
%
%   Set OptimOptions = [] to use dafaults optimization options

tt=t(find(t<=LKWindow(2)));
ZZ=Z(:,1:length(tt));

EstimOptions{1}=tt;
EstimOptions{2}=ZZ;
EstimOptions{3}=Xf00;
EstimOptions{4}=Pf0;
EstimOptions{5}=theta0;
EstimOptions{6}=FileNames;
EstimOptions{7}=LKWindow;
EstimOptions{9}=nu_stast;
EstimOptions{10}=LB;
EstimOptions{11}=UB;
EstimOptions{12}=OptimOptions;
EstimOptions{16}=mpts;
EstimOptions{17}=OptimMethod;

if (nargin>=14) && (~isempty(AbsTol)), 
    Atol=AbsTol;     
else
    Atol=1.0e-6;
end
if (nargin==15) && (~isempty(RelTol)), 
    Rtol=RelTol; 
else
    Rtol=1.0e-3;
end
EstimOptions{18}=Atol;
EstimOptions{19}=Rtol;

[var_est,V_est,Xp,Pp,nu,LogLK0] = LLfilter(tt,ZZ,Xf00,Pf0,theta0,FileNames,LKWindow,mpts,Atol,Rtol);
EstimOptions{8} = LogLK0;   

disp(['  '])
% Log likelihood for the initial parameters Xf00 and theta0 (this is for normalization propose)
disp([' Log LK for Theta0= ' num2str(-LogLK0)])



