global deltat deltat_min n_v_e n_m n_obs t0 tTotal X0 Xf0 Pf0 mpts
global theta FileNames

deltat_min=0.0001;  % sampling period for integration
deltat=1;           % sampling period for filtering
t0=0;               % initial time  
tTotal=t0+30;       % sampling time  

% definition of state space parameters

n_obs=1; % number of observation equations
%n_obs=2; % number of observation equations
n_v_e=2; % number of state variables  
n_w=1;
n_m=round((tTotal - t0) ./ deltat)   %number of points
%mpts=0.*ones(1,n_m);   % number of misssing points to compute the prediction between two observations
mpts=[];
AbsTol=[5.0e-9,5.0e-12];
RelTol=[5.0e-6,5.0e-6];

X0=[1 1]';                 % initial state variable for integration;
Xf0=X0;                    % initial filter estimates
Pf0=zeros(2);              % initial filter variance estimates

theta(1)=1;
theta(2)=1;
theta(3)=0.5;
theta(4)=0.75;           % system noise
theta(5)=0.001;          % observation noise

f  = @F_VanderPolAdd;    % name of function f
g  = @G_VanderPolAdd;    % name of function g 
Jf = @J_VanderPolAdd;    % name of Jacobian of f
Jg = 'zero';              % name of Jacobian of g  
Hf = 'zero';              % name of the Hessian of f
Hg = 'zero';              % name of the Hessian of g 
ft = 'zero';              % name of derivative of f respect to t   
gt = 'zero';              % name of derivative of g respect to t

h  = @H_VanderPolAdd;    % name of function h
Jh = @Jh_VanderPolAdd;   % name of Jacobiano de h 

p  = 'zero';    % name of function p  
Jp = 'zero';   % name of Jacobian of p  

See= @See_VanderPolAdd;  % variance of the additive observation noise
Lee= @Lee_VanderPolAdd;  % variance of the multiplicative observation noise

FileNames=MakeFileNames(f,g,Jf,Jg,Hf,Hg,ft,gt,h,Jh,p,Jp,See,Lee);


