%This procedure use Maximum Likelihood method to estimate parameters thetae of the
% Hodgkin-Huxley model using LL filtering and innovation approach

clear all
global deltat deltat_min n_v_e n_m n_obs t0 tTotal X0
global FileNames
global theta_i theta
global mpts

% parhh;
% consthh;
genhh
thetae=theta(theta_i);
% load data 
Z=datos;

Xf0=X0;
Pf0=1.0e-9.*diag(ones(1,n_v_e));
LKWindow=[0 tTotal];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This part is to calculate the true filter (true parameters)
% compute the LL filter
[var_est,V_est,tp,Xp,Pp,nu,LK]=LLfilter(t,Z,Xf0,Pf0,thetae,FileNames,LKWindow,mpts);
% plot of the state variable and their filter estimates
load rstates
figure
subplot(411)
plot(t,proceso(1,:),t,var_est(1,:));
subplot(412)
plot(t,proceso(2,:),t,var_est(2,:));
subplot(413)
plot(t,proceso(3,:),t,var_est(3,:));
subplot(414)
plot(t,proceso(4,:),t,var_est(4,:));
% plot of the innovations
figure;
plot(nu);
drawnow;
for pp=1:length(thetae)
    disp(['True Parameter #' num2str(pp) ' Value = ' num2str(thetae(pp))])
end
disp(['Real Likelihood Value = ' num2str(LK)])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This part is to Illustrate the Maximum Likelihood method
% compute the LL filter
Np=100;
thetav=zeros(length(thetae),Np+1);
StepTheta=zeros(1,length(thetae));
for pp =1:length(thetae)
    StepTheta(pp)=(thetae(pp)+thetae(pp)./2-(thetae(pp)-thetae(pp)./2))/Np;
    thetav(pp,:)=thetae(pp)-thetae(pp)/2:StepTheta(pp):thetae(pp)+thetae(pp)/2;
end
LKv=zeros(1,Np+1);
for kk=1:Np+1
 disp(['Iteration = ' num2str(kk)])
 [var_est,V_est,tp,Xp,Pp,nu,LKv(kk)]=LLfilter(t,Z,Xf0,Pf0,thetav(:,kk)',FileNames,LKWindow,mpts);
end
% plot of the likelihhod
for pp=1:length(thetae)
 figure;
 plot(thetav(pp,:),LKv)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This part is to calculate the filter in the initial parameters
% Intial values
theta0e = thetae + 15.0 .* (2.*rand(1,max(size(thetae))) - 1);
for pp=1:length(thetae)
    disp(['Initial Parameter #' num2str(pp) ' Value = ' num2str(theta0e(pp))])
end
% compute the LL filter
[var_est,V_est,tp,Xp,Pp,nu,LK]=LLfilter(t,Z,Xf0,Pf0,theta0e,FileNames,LKWindow,mpts);
% plot of the state variable and their filter estimates
figure
subplot(411)
plot(t,proceso(1,:),t,var_est(1,:));
subplot(412)
plot(t,proceso(2,:),t,var_est(2,:));
subplot(413)
plot(t,proceso(3,:),t,var_est(3,:));
subplot(414)
plot(t,proceso(4,:),t,var_est(4,:));
% plot of the innovations
figure;
plot(nu);
drawnow;
disp(['Initial Likelihood Value =' num2str(LK)])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This part is to make inference about the parameters and state from the data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Warning. These varaiables have to be modified when changing the parameters to be estimated 
LBe=0.001;
UBe=30;

Opts = optimset('fmincon');
Opts = optimset(Opts,'LargeScale','off','Display','iter','MaxFunEvals',30000,'TolCon',1e-8,'TolFun',1e-10,'TolX',1e-8);
Theta_este=fmincon('filter_hh',theta0e,[],[],[],[],LBe,UBe,[],Opts);

[LKe,var_este,V_este,tpe,Xpe,Ppe,nue]=filter_hh(Theta_este);

figure
subplot(411)
plot(t,proceso(1,:),t,var_este(1,:));
subplot(412)
plot(t,proceso(2,:),t,var_este(2,:));
subplot(413)
plot(t,proceso(3,:),t,var_este(3,:));
subplot(414)
plot(t,proceso(4,:),t,var_este(4,:));
% plot of the innovations
figure;
plot(nue);
drawnow;
disp(['Estimated Likelihood Value =' num2str(LKe)])

disp(['   '])
disp('        List of the estimated parameters ')
disp('thetae          theta0e          Theta_est')
[thetae' theta0e' Theta_este']