% Neuron's model
% Parameters
global gmax Veq Vmr Cm RT_F tau rm
global alpha0m alpha0h alpha0n ganmam zm V12m ganmah zh V12h ganman zn V12n
global IAppl

% Physics Constants

% (C / mol) (J / (mol K))   (K)
F = 96485;    R = 8.314;   T = 30 + 273; 

%      (mV)
RT_F = 1000 .* R .* T ./ F;

% Order Na K Leak
gmax = [15, 2, 5.0e-3];  % mS/cm^2  [0 0 5.0e-3];
Veq = [50, -100, -68];   % [50, -100, -69];   % mV
Vmr = -65;               % mV
Cm = 0.75;               % microF/cm^2;
rm = 40;                 % kOhm cm2
tau = Cm * rm;           % ms -> membrane constant

% Order m h n
alpha0m=4.2; ganmam = 0.7;  zm =  3.3; V12m = -34.5;
alpha0h=0.09; ganmah = 0.27; zh = -3.0; V12h = -45;
alpha0n=0.3; ganman = 0.8;  zn =  3.0; V12n = -35;
ganma=[ganmam ganmah ganman];z=[zm zh zn];V12=[V12m V12h V12n];alpha0=[alpha0m alpha0h alpha0n];
beta0=alpha0;
Varoo=alphac(alpha0,z,ganma,V12,Vmr)./(alphac(alpha0,z,ganma,V12,Vmr)+betac(beta0,z,ganma,V12,Vmr));

IAppl = -1; % uA/cm2
IAppl = IAppl * rm;
n_obs=1; % number of observation equations
Seen=1.0;2.5;%2.5; % Observation noise
Sig=1.8; % System noise in the membrane potential

% For the LL filter
Xf0=[Varoo';Vmr]; % This must be same as X0;
Pf0=1.0e-9.*diag(ones(1,length(Xf0)));

theta(1)=ganmam; theta(2)=zm;  theta(3)=V12m;  theta(4)=alpha0m; 
theta(5)=ganmah; theta(6)=zh;  theta(7)=V12h;  theta(8)=alpha0h; 
theta(9)=ganman; theta(10)=zn; theta(11)=V12n; theta(12)=alpha0n; 
theta(13)=Sig; theta(14)=IAppl; theta(15)=Seen;
theta(16:18)=gmax; theta(19:19+length(Xf0)-1)=Xf0'; theta(19+length(Xf0):19+2*length(Xf0)-1)=diag(Pf0)';

theta_i=[16];
